---
title: Animation performance and frame rate
slug: Web/Performance/Animation_performance_and_frame_rate
tags:
  - CSS animation
  - Developer Tools
  - Web Performance
---
<p>{{draft}}</p>

<p>Animation on the web can be done via {{domxref('SVGAnimationElement', 'SVG')}}, {{domxref('window.requestAnimationFrame','JavaScript')}}, including {{htmlelement('canvas')}} and {{domxref('WebGL_API', 'WebGL')}}, CSS {{cssxref('animation')}}, {{htmlelement('video')}}, animated gifs and even animated PNGs and other image types. The performance cost of animating a CSS property can vary from one property to another, and animating expensive CSS properties can result in {{glossary('jank')}} as the browser struggles to hit a smooth {{glossary('frame rate')}}.</p>

<p>For animated media, such as video and animated gifs, the main performance concern is file size - downloading the file size fast enough to not negatively impact performance is the greatest issue. Code based animations, be it CSS, SVG, &lt;canvas&gt;, webGL or other JavaScript animations, can cause performance issues even if the bandwidth footprint is small. These animations can consume CPU and/or cause jank.</p>

<p>While performance is sensitive to the particular system and its load, performance tools can help you understand the work the browser's doing to render your site, and help you prevent and diagnose problems when they occur.</p>

<p>Users expect all interface interactions to be smooth and all user interfaces to be responsive. Animation can help make a site feel faster and responsive, but animations can also make a site feel slower and janky if not done correctly. Responsive user interfaces have a frame rate of <a href="/en-US/docs/Tools/Performance/Frame_rate">60 frames per second (fps)</a>. While it is not always possible to maintain 60fps, it is important to maintain a high and steady frame rate for all animations. Let's take a look at how we can use browser tools to inspect the frame rate. We'll also discuss some tips to create and maintain a fast and steady frame rate.</p>

<p>The developer tool's <a href="/en-US/docs/Tools/Performance/Frame_rate">frame rate</a> and <a href="/en-US/docs/Tools/Performance/Waterfall">waterfall</a> charts provide insight into the work the browser is performing to animate code. Using these tools you can measure an application's animation frame rate, and diagnose performance bottlenecks if any are found.</p>

<p>With <a href="/en-US/docs/Web/Guide/CSS/Using_CSS_animations">CSS animations</a> you specify a number of <a href="/en-US/docs/Web/CSS/@keyframes">keyframes</a>, each of which uses CSS to define the appearance of the element at a particular stage of the animation. The browser creates the animation as a transition from each keyframe to the next.</p>

<p>Compared with animating elements using JavaScript, CSS animations can be easier to create. They can also give better performance, as they give the browser more control over when to render frames, and to drop frames if necessary.</p>

<p>However, the performance cost of modifying a CSS property can vary from one property to another. It's commonly accepted that 60 frames per second is the rate at which animations will appear smooth. For a rate of 60 frames per second, the browser has 16.7 milliseconds to execute scripts, recalculate styles and layout if needed, and repaint the area being updated. Slow scripts and animating expensive CSS properties can result in <a href="/en-US/docs/Glossary/Jank">jank</a> as the browser struggles to hit a smooth frame rate.</p>

<h2 id="The_rendering_waterfall">The rendering waterfall</h2>

<p>The process a browser uses to paint changes to a page when an element is animating CSS properties can be described as a waterfall consisting of the following steps:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10821/css-rendering-waterfall.png" style="display: block; height: 203px; margin-left: auto; margin-right: auto; width: 546px;"></p>

<ol>
 <li><strong>Recalculate Style</strong>: when a property for an element changes, the browser must recalculate computed styles.</li>
 <li><strong>Layout</strong>: next, the browser uses the computed styles to figure out the position and geometry for the elements. This operation is labeled "layout" but is also sometimes called "reflow".</li>
 <li><strong>Paint</strong>: finally, the browser needs to repaint the elements to the screen. One last step is not shown in this sequence: the page may be split into layers, which are painted independently and then combined in a process called "Composition".</li>
</ol>

<p>The process a browser uses to paint updated changes to a canvas element is different. In the &lt;canvas&gt; scenario, the page layout is not changing. Rather, the page is being repainted, repeatedly, based on JavaScript canvas API functions.  When a canvas is animating a drawing, the canvas animation can be described as a waterfall consisting of the following steps:</p>

<p>These sequenced need to fit into a single frame, since the screen isn't updated until it is complete.</p>

<h2 id="CSS_property_cost">CSS property cost</h2>

<p>In the context of the rendering waterfall, some properties are more expensive than others:</p>

<table class="fullwidth-table standard-table">
 <thead>
  <tr>
   <th scope="col">Property type</th>
   <th scope="col">Cost</th>
   <th scope="col">Examples</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>Properties that affect an element's <em>geometry</em> or <em>position</em> trigger a style recalculation, a layout and a repaint.</td>
   <td><img alt="" src="https://mdn.mozillademos.org/files/10827/recalculate-style.png" style="height: 26px; width: 123px;"> <img alt="" src="https://mdn.mozillademos.org/files/10825/layout.png" style="height: 26px; width: 123px;"> <img alt="" src="https://mdn.mozillademos.org/files/10823/paint.png" style="height: 26px; width: 123px;"></td>
   <td>
    <p><code><a href="/en-US/docs/Web/CSS/left">left</a></code><br>
     <code><a href="/en-US/docs/Web/CSS/max-width">max-width</a></code><br>
     <code><a href="/en-US/docs/Web/CSS/border-width">border-width</a></code><br>
     <code><a href="/en-US/docs/Web/CSS/margin-left">margin-left</a></code><br>
     <code><a href="/en-US/docs/Web/CSS/font-size">font-size</a></code></p>
   </td>
  </tr>
  <tr>
   <td>
    <p>Properties that don't affect geometry or position, but are not rendered in their own layer, do not trigger a layout.</p>
   </td>
   <td><img alt="" src="https://mdn.mozillademos.org/files/10827/recalculate-style.png" style="height: 26px; width: 123px;"> <img alt="" src="https://mdn.mozillademos.org/files/10835/layout-faint.png" style="height: 52px; width: 123px;"> <img alt="" src="https://mdn.mozillademos.org/files/10823/paint.png" style="height: 26px; width: 123px;"></td>
   <td>
    <p><code><a href="/en-US/docs/Web/CSS/color">color</a></code></p>
   </td>
  </tr>
  <tr>
   <td>Properties that are rendered in their own layer don't even trigger a repaint, because the update is handled in composition.</td>
   <td><img alt="" src="https://mdn.mozillademos.org/files/10827/recalculate-style.png" style="height: 26px; width: 123px;"> <img alt="" src="https://mdn.mozillademos.org/files/10835/layout-faint.png" style="height: 52px; width: 123px;"> <img alt="" src="https://mdn.mozillademos.org/files/10839/paint-faint.png" style="height: 26px; width: 123px;"></td>
   <td><code><a href="/en-US/docs/Web/CSS/transform">transform</a></code><br>
    <code><a href="/en-US/docs/Web/CSS/opacity">opacity</a></code></td>
  </tr>
 </tbody>
</table>

<div class="note">
<p>The <a href="http://csstriggers.com/">CSS Triggers</a> website shows how much of the waterfall is triggered for each CSS property, with information for most CSS properties by browser engine.</p>
</div>

<h2 id="An_example_margin_versus_transform">An example: margin versus transform</h2>

<p>In this section we'll see how the <a href="/en-US/docs/Tools/Performance/Waterfall">Waterfall</a> can highlight the difference between animating using <code><a href="/en-US/docs/Web/CSS/margin">margin</a></code> and animating using <code><a href="/en-US/docs/Web/CSS/transform">transform</a></code>.</p>

<p>The intention of this scenario isn't to convince you that animating using <code>margin</code> is always a bad idea. It's to demonstrate how the tools can give you insight into the work the browser is doing to render your site, and how you can apply that insight to diagnose and fix performance problems.</p>

<p>If you want to play along, the demo website is <a href="https://mdn.github.io/performance-scenarios/animation-transform-margin/index.html">here</a>. It looks like this:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/11029/css-animations-demo.png" style="display: block; height: 677px; margin-left: auto; margin-right: auto; width: 1000px;">It has two controls: a button to start/stop the animation, and a radio group to choose to animate using <code>margin</code>, or to animate using <code>transform</code>.</p>

<p>There are a number of elements, and we've added a <code><a href="/en-US/docs/Web/CSS/linear-gradient">linear-gradient</a></code> background and a <code><a href="/en-US/docs/Web/CSS/box-shadow">box-shadow</a></code> to each element, because they are both relatively expensive effects to paint.</p>

<p>There's also a video version of this walkthrough:</p>

<p>{{EmbedYouTube("Tvu6_j8Qzfk")}}</p>

<h3 id="Animating_using_margin">Animating using margin</h3>

<p>Leaving the "Use margin" option set, start the animation, open the Performance tool, and make a recording. You'll only need to record a few seconds.</p>

<p>Open up the first recording. Exactly what you'll see depends a lot on your machine and system load, but it will be something like this:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10853/margin-recording.png" style="display: block; height: 237px; margin-left: auto; margin-right: auto; width: 800px;"></p>

<p>This is showing three distinct views: (a) an overview of the Waterfall, (b) the frame rate, and (c) the timeline details.</p>

<h4 id="Waterfall_overview">Waterfall overview</h4>

<p><img alt="" src="https://mdn.mozillademos.org/files/10857/margin-timeline-overview.png" style="display: block; height: 58px; margin-left: auto; margin-right: auto; width: 800px;"></p>

<p>This is showing a compressed view of the <a href="/en-US/docs/Tools/Performance/Waterfall">Waterfall</a>. The predominance of green is telling us that <a href="/en-US/docs/Tools/Performance/Timeline#timeline-color-coding">we're spending a lot of time painting</a>.</p>

<h4 id="Frame_rate">Frame rate</h4>

<p><img alt="" src="https://mdn.mozillademos.org/files/10859/margin-frame-rate.png" style="display: block; height: 64px; margin-left: auto; margin-right: auto; width: 800px;"></p>

<p>This is showing <a href="/en-US/docs/Tools/Performance/Frame_rate">frame rate</a>. Average frame rate here is 46.67fps, well below the target of 60fps. Worse, though, is that the frame rate is very jagged, with lots of dips into the twenties and teens. It's unlikely you'll see a smooth animation here, especially when you add in user interaction.</p>

<h4 id="Waterfall">Waterfall</h4>

<p>The rest of the recording shows the Waterfall view. If you scroll through this, you'll see a pattern like this:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10861/margin-timeline.png" style="display: block; height: 532px; margin-left: auto; margin-right: auto; width: 800px;"></p>

<p>This is showing us the <a href="/en-US/docs/Tools/Performance/Scenarios/Animating_CSS_properties#The_CSS_rendering_waterfall">rendering waterfall</a>. In each animation frame, we recalculate styles for every element, then perform a single layout, then a repaint.</p>

<p>You can see that paint especially is hurting performance here. In the screenshot above we've highlighted a paint operation, and the box on the right tells us it took 13.11ms. With only 16.7ms in our total budget, it's not surprising we are missing a consistently high frame rate.</p>

<p>You can experiment with this: try removing the box shadow <a href="/en-US/docs/Tools/Page_Inspector/How_to/Examine_and_edit_CSS">using the Page Inspector</a>, and see how that affects paint time. But next, we'll see how using <code><a href="/en-US/docs/Web/CSS/transform">transform</a></code> instead of <code><a href="/en-US/docs/Web/CSS/margin">margin</a></code> eliminates those expensive paints entirely.</p>

<h3 id="Animating_using_transform">Animating using transform</h3>

<p>Now switch the radio button in the web page to "Use transform", and make a new recording. It will look something like this:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10863/transform-recording.png" style="display: block; height: 234px; margin-left: auto; margin-right: auto; width: 800px;"></p>

<h4 id="Waterfall_overview_2">Waterfall overview</h4>

<p><img alt="" src="https://mdn.mozillademos.org/files/10869/transform-timeline-overview.png" style="display: block; height: 57px; margin-left: auto; margin-right: auto; width: 800px;"></p>

<p>Compared with <a href="/en-US/docs/Tools/Performance/Scenarios/Animating_CSS_properties#Waterfall_overview">the version that uses margin</a>, we're seeing a lot less green and a lot more pink, which<a href="/en-US/docs/Tools/Performance/Waterfall#timeline-color-coding"> could be either layout or style recalculation</a>.</p>

<h4 id="Frame_rate_2">Frame rate</h4>

<p><img alt="" src="https://mdn.mozillademos.org/files/10865/transform-frame-rate.png" style="display: block; height: 62px; margin-left: auto; margin-right: auto; width: 800px;"></p>

<p>Compared with <a href="/en-US/docs/Tools/Performance/Scenarios/Animating_CSS_properties#Frame_rate">the version that uses margin</a>, this is looking pretty good. We're averaging nearly 60fps, and apart from one dip near the start, we're getting a consistently high frame rate.</p>

<h4 id="Waterfall_2">Waterfall</h4>

<p>The timeline view shows the reason for the improved frame rate. Compared with <a href="/en-US/docs/Tools/Performance/Scenarios/Animating_CSS_properties#Waterfall">the version that uses margin</a>, we're not spending any time in layout or (more importantly in this case) in paint:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/10867/transform-timeline.png" style="display: block; height: 384px; margin-left: auto; margin-right: auto; width: 800px;"></p>

<p>In this case, using <code>transform</code> significantly improved the site's performance, and the performance tools were able to show how and why it did.</p>
